﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;

namespace WinGrid_RadioButtonPerGroup_CS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.ultraGrid1.Rows.ExpandAll(true);

            
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            UltraGridLayout layout = e.Layout;
            UltraGridBand band = layout.Bands[0];

            UltraGridColumn column = band.Columns.Add("Selected");
            column.DataType = typeof(bool);
            column.Header.VisiblePosition = 1;
            column.Header.Caption = " ";
            
            // Use an editor to make the CheckBox look like a radio button. 
            column.EditorComponent = this.ultraCheckEditor1;

            layout.ViewStyleBand = ViewStyleBand.OutlookGroupBy;
            band.SortedColumns.Add("Id", false, true);
        }

        private void ultraGrid1_CellChange(object sender, CellEventArgs e)
        {
            if (e.Cell.Column.Key == "Selected")
            {
                bool selected = bool.Parse(e.Cell.Text);
                if (selected)
                {
                    foreach (UltraGridRow row in e.Cell.Row.ParentCollection)
                    {
                        if (row == e.Cell.Row)
                            continue;

                        row.Cells["Selected"].Value = false;
                        row.Update();
                    }
                }
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Make this CheckEditor look like a RadioButton. 
            this.ultraCheckEditor1.GlyphInfo = UIElementDrawParams.RadioButtonGlyphInfo;
            this.ultraCheckEditor1.Text = string.Empty;
            this.ultraCheckEditor1.CheckAlign = ContentAlignment.MiddleCenter;
        }
    }
}
